#include <iostream>

using namespace std;

class bad_index {};

template <typename T>
class Vector {
public:
	Vector(unsigned int sz): arr_(0), sz_(sz), capacity_(sz), next_(0)
	{
		arr_ = new T[sz_];
		cout << "constructor for Vector<T> called\n";
	}

	T& operator [](unsigned int i)
	{
		return arr_[i];
	}

	T& at(unsigned int i)
	{
		if (i > sz_) throw bad_index();
		return arr_[i];
	}

	void add_back(const T& elem)
	{
		if (next_ == capacity_)
			alloc_more();
		arr_[next_++] = const_cast<T&>(elem);
	}

private:
	void alloc_more()
	{
		T* newarr = new T[capacity_ + 10];
		for (unsigned int i = 0; i < capacity_; ++i)
		{
			newarr[i] = arr_[i];
		}
		arr_ = newarr;
		capacity_ += 10;
	}

	T*  arr_;
	unsigned int sz_;
	unsigned int capacity_;
	unsigned int next_;
};

#ifdef USE_SPECIALIZATION
template <>
class Vector<void*> {
public:
	Vector(unsigned int sz): arr_(0), sz_(sz), capacity_(sz), next_(0)
	{
		arr_ = new void*[sz_];
		cout << "constructor for Vector<void*> called\n";
	}

	void*& operator [](unsigned int i)
	{
		return arr_[i];
	}

	void*& at(unsigned int i)
	{
		if (i > sz_) throw bad_index();
		return arr_[i];
	}

	void add_back(const void* elem)
	{
		if (next_ == capacity_)
			alloc_more();
		arr_[next_++] = const_cast<void*&>(elem);
	}

private:
	void alloc_more()
	{
		void** newarr = new void*[capacity_ + 10];
		for (unsigned int i = 0; i < capacity_; ++i)
		{
			newarr[i] = arr_[i];
		}
		arr_ = newarr;
		capacity_ += 10;
	}

	void** arr_;
	unsigned int sz_;
	unsigned int capacity_;
	unsigned int next_;
};

template <typename T>
class Vector<T*> : private Vector<void*> {
public:
	Vector(unsigned int sz) : Vector<void*>(sz)
	{
	}

	T*& operator [](unsigned int i)
	{
		return (T*&)Vector<void*>::operator [](i);
	}

	T*& at(unsigned int i)
	{
		return (T*&)Vector<void*>::at(i);
	}

	void add_back(const T* elem)
	{
		Vector<void*>::add_back(elem);
	}
};
#endif

int main()
{
	Vector<int*> vpi(10);
	vpi[0] = new int(10);
	vpi.at(0);
	vpi.add_back(new int);

	Vector<double*> vpd(10);
	vpd[0] = new double(1.1);
	vpd.at(0);
	vpd.add_back(new double);

	Vector<float*> vpf(10);
	vpf[0] = new float(1.2);
	vpf.at(0);
	vpf.add_back(new float);

	Vector<bool*> vpb(10);
	vpb[0] = new bool(true);
	vpb.at(0);
	vpb.add_back(new bool);

	Vector<short*> vps(10);
	vps[0] = new short(100);
	vps.at(0);
	vps.add_back(new short);

	Vector<char*> vpc(10);
	vpc[0] = new char('A');
	vpc.at(0);
	vpc.add_back(new char);

	Vector<long*> vpl(10);
	vpl[0] = new long(100);
	vpl.at(0);
	vpl.add_back(new long);

	Vector<long long*> vpll(10);
	vpll[0] = new long long();
	vpll.at(0);
	vpll.add_back(new long long);

	Vector<unsigned*> vpu(10);
	vpu[0] = new unsigned();
	vpu.at(0);
	vpu.add_back(new unsigned);

	Vector<unsigned short*> vpus(10);
	vpus[0] = new unsigned short();
	vpus.at(0);
	vpus.add_back(new unsigned short);

	Vector<unsigned long*> vpul(10);
	vpul[0] = new unsigned long();
	vpul.at(0);
	vpul.add_back(new unsigned long);

	Vector<unsigned long long*> vpull(10);
	vpull[0] = new unsigned long long();
	vpull.at(0);
	vpull.add_back(new unsigned long long());

	Vector<long double*> vpuld(10);
	vpuld[0] = new long double();
	vpuld.at(0);
	vpuld.add_back(new long double);
#if 0
#endif

	return 0;
}

